package com.sample.vsml;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;

import com.vaadin.annotations.Push;
import com.vaadin.annotations.Theme;
import com.vaadin.annotations.VaadinServletConfiguration;
import com.vaadin.server.CustomizedSystemMessages;
import com.vaadin.server.SystemMessages;
import com.vaadin.server.SystemMessagesInfo;
import com.vaadin.server.SystemMessagesProvider;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinServlet;
import com.vaadin.shared.ui.ui.Transport;
import com.vaadin.ui.Button;
import com.vaadin.ui.Button.ClickEvent;
import com.vaadin.ui.Label;
import com.vaadin.ui.UI;
import com.vaadin.ui.VerticalLayout;

/**
 *
 */
@SuppressWarnings("serial")
@Push(transport=Transport.STREAMING)
@Theme("valo")
public class MyUI extends UI {

    @Override
    protected void init(VaadinRequest vaadinRequest) {
    	vaadinRequest.getWrappedSession().setMaxInactiveInterval(5);
    	final VerticalLayout layout = new VerticalLayout();
        layout.setMargin(true);
        setContent(layout);

        Button button = new Button("Click Me");
        button.addClickListener(new Button.ClickListener() {
            @Override
            public void buttonClick(ClickEvent event) {
                layout.addComponent(new Label("Thank you for clicking"));
            }
        });
        layout.addComponent(button);

    }

    @WebServlet(urlPatterns = "/*", name = "MyUIServlet", asyncSupported = true)
    @VaadinServletConfiguration(ui = MyUI.class, productionMode = false, heartbeatInterval=3, closeIdleSessions=true)
    public static class MyUIServlet extends VaadinServlet {
    	@Override
        protected void servletInitialized() throws ServletException
        {
            super.servletInitialized();
            getService().setSystemMessagesProvider(new SystemMessagesProvider() {
				
				@Override
				public SystemMessages getSystemMessages(
						SystemMessagesInfo systemMessagesInfo) {
					CustomizedSystemMessages csm = new CustomizedSystemMessages();
					
					csm.setSessionExpiredCaption("Session expired - öüóőúéáűíÖÜÓŐÚÉÁŰÍ");
					csm.setSessionExpiredMessage(csm.getSessionExpiredMessage() + "öüóőúéáűíÖÜÓŐÚÉÁŰÍ");
					
					return csm;
				}
			});
        }
    }
}
